=== tests/requirements.txt ===
flake8
nose
coverage
eventlet
mitogen
bottle
sphinx
