=== changelog ===
vim (2:8.1.0875-5) unstable; urgency=medium

  * gbp.conf: Set debian-tag to debian/%(version)s
  * Backport 'modelineexpr' patches to further restrict modelines
    + 8.1.1366: Using expressions in a modeline is unsafe
    + 8.1.1367: can set 'modelineexpr' in modeline
    + 8.1.1368: Modeline test fails with python but without pythonhome
    + 8.1.1382: Error when editing test file
    + 8.1.1401: misspelled mkspellmem as makespellmem (test fix)

 -- James McCoy <jamessan@debian.org>  Sat, 15 Jun 2019 12:41:15 -0400

vim (2:8.1.0875-4) unstable; urgency=high

  * Backport 8.1.1046 and 8.1.1365 to fix CVE-2019-12735  (Closes: #930020)
    + 8.1.1365: source command doesn't check for the sandbox

 -- James McCoy <jamessan@debian.org>  Fri, 07 Jun 2019 06:49:19 -0400

vim (2:8.1.0875-3) unstable; urgency=medium

  * syntax/deb{changelog,sources}: Update release names for Debian/Ubuntu
    (Closes: #927167)

 -- James McCoy <jamessan@debian.org>  Sun, 05 May 2019 23:41:10 -0400

vim (2:8.1.0875-2) unstable; urgency=medium

  * Backport 8.1.0878 and 8.1.0884 to fix test failures on kFreeBSD.
  * Backport 8.1.0948 to avoid enabling filetype detection when the +eval
    feature isn't present.  (Closes: #922106)

 -- James McCoy <jamessan@debian.org>  Fri, 22 Feb 2019 07:55:04 -0500

vim (2:8.1.0875-1) unstable; urgency=medium

  * Merge upstream patch v8.1.0875
    + "autocmd", "multi_byte", "virtualedit", and "visualextra" features are
      now always enabled.
    + New Blob type, for working with raw bytes.
    + Support a 3rd character for the "tab" setting in the 'listchars' option.
    + *.com files under /etc/apache2/sites-* are properly recognized as apache
       filetype.  (Closes: #740387)
    + syntax/debchangelog.vim: Recognize "emergency" as a valid urgency.
      (Closes: #920522)
    + Support 64-bit offsets for xxd.  (Closes: #771456)
  * rules:
    + Remove --enable-multibyte since it is always enabled
  * debian.vim:
    + Remove has('autocmd') checks since it is always enabled
  * gvimrc:
    + Adapt gui check to work for gtk2/gtk3

 -- James McCoy <jamessan@debian.org>  Mon, 04 Feb 2019 23:11:09 -0500

vim (2:8.1.0693-2) unstable; urgency=medium

  * Separate /etc/vim and /usr/share/vim/vimfiles.  The former should be for
    the sysadmin, while the latter is used by packages.
    + Make /usr/share/vim/vimfiles a directory, not a symlink to /etc/vim
    + Add /etc/vim to the default 'runtimepath'

 -- James McCoy <jamessan@debian.org>  Sat, 05 Jan 2019 15:53:12 -0500

vim (2:8.1.0693-1) unstable; urgency=medium

  * Merge upstream tag v8.1.0693
  * control:
    + Remove obsolete vim-gnome package
    + Remove ${shlibs:Depends} from vim-common, since it is Arch: all
    + Build-Depend on libtool-bin to run libterm tests
    + Replace libtinfo-dev Build-Depends with libncurses-dev
    + Change Homepage to https://www.vim.org/
  * Use debian/clean to cleanup files/directories
  * rules:
    + Rename stamp files so dh_clean deletes them automatically
    + Ensure helptags are generated before running tests
  * Declare compliance with Policy 4.3.0, no changes needed

 -- James McCoy <jamessan@debian.org>  Sat, 05 Jan 2019 12:34:12 -0500

vim (2:8.1.0549-1) unstable; urgency=medium

  * Merge upstream tag v8.1.0549
    + Built-in support for performing diffs, via the libxdiff library, which
      allows setting the diff algorithm (:help 'diffopt').
    + Fix formatting of example output in translated xxd man pages.  (Closes:
      #909217)
  * gitlab-ci.yml: Run build as non-root user
  * Mark vim-common Multi-Arch: foreign (Closes: #910732)

 -- James McCoy <jamessan@debian.org>  Tue, 27 Nov 2018 20:38:28 -0500

vim (2:8.1.0320-1) unstable; urgency=medium

  * Merge upstream tag v8.1.0320
    - syntax/debcontrol.vim:
      + Recognize riscv64 as an architecture (Closes: #905435)
    - syntax/sh.vim:
      + Fix syntax highlighting of curly braces inside parameter expansion
        (Closes: #904875)
  * rules:
    + Stop using --dbgsym-migration
    + Stop overriding default dpkg-deb compression
  * Declare compliance with Policy 4.2.0, no changes needed
  * control: Add cscope to Build-Depends to test cscope integration

 -- James McCoy <jamessan@debian.org>  Wed, 22 Aug 2018 19:46:39 -0400

vim (2:8.1.0229-1) unstable; urgency=medium

  [ upstream ]
  * Unicode 11 support
  * New options ('vartabstop'/'varsofttabstop') to define variable width tab
    stops.
  * Danish translation

  [ James McCoy ]
  * Change "Compiled by" string to team+vim@tracker.d.o
  * rules:
    + Only run scratch target, not distclean, in autoconf-stamp to avoid FTBFS
      with parallel builds.
    + Allow defining VARIANT from the environment.  Thanks to Guillem Jover
      for the suggestion (Closes: #903927)
  * Change vim-python Provides to vim-python3.  While Vim only supports py2 or
    py3, Neovim supports both so the change in provides allows
    python(3)-neovim to differentiate the supported Python version.

 -- James McCoy <jamessan@debian.org>  Thu, 02 Aug 2018 21:44:43 -0400

vim (2:8.1.0089-1) unstable; urgency=medium

  * New upstream release
    + New syntax highlighting for machine-readable debian/copyright files.
      (Closes: #869965)
    + Fix mis-highlighting of architectures in debian/control files.  (Closes:
      #900476)
  * Change Maintainer to team+vim@tracker.debian.org
  * Add wildcard to binaries-have-file-conflict override between
    vim-tiny/vim-runtime to account for upstream releases.

 -- James McCoy <jamessan@debian.org>  Tue, 19 Jun 2018 22:44:05 -0400

vim (2:8.0.1766-1) unstable; urgency=medium

  [ David Rabel ]
  * d/copyright: Fix path to tee.c

  [ upstream ]
  * 8.0.1477: Avoid cursor flicker when changing (de)focusing the terminal.
    (Closes: #890642)
  * 8.0.1491: New 'pumwidth' option allows controlling the width of the popup
    menu.  (Closes: #450481)
  * 8.0.1744: Skip Test_writefile_sync_dev_stdout when /dev/stdout isn't

