=== src/packaging/debian/changelog ===
cassandra-reaper (0.2.3-1) stable; urgency=low

  * Add config option for default ScheduleDaysBetween
  * REST API: Get repair schedule by keyspace[+cluster], get clusters by seed
  * Decrease scheduler wakeup time to 10 minutes
  * Cancel all running repairs on nodes where Reaper has no commands running

 -- Björn Hegerfors <bj0rn@spotify.com>  Mon, 16 Nov 2015 16:05:51 +0100

cassandra-reaper (0.2.2-1) stable; urgency=low

  * Fix JMX connection leak
  * Include full date on log lines
  * Fix problem with scheduling fan out
  * Improve repair resuming logic after errors

 -- Hannu Varjoranta <varjo@spotify.com>  Fri, 28 Aug 2015 13:50:01 +0200

cassandra-reaper (0.2.1-1) stable; urgency=low

  * Fixed race condition bug with parallel repairs
  * Fixed bug with failing repair schedule blocking all other schedules
  * Catch exceptions to avoid unnecessarily putting runs in ERROR state
  * Allow reattempting ERROR runs from where they left off

 -- Björn Hegerfors <bj0rn@spotify.com>  Wed, 6 May 2015 15:10:06 +0200

cassandra-reaper (0.2.0-1) stable; urgency=low

  * Add parallel opportunistic repairs
  * Add CORS headers for external GUI

 -- Hannu Varjoranta <varjo@spotify.com>  Fri, 10 Apr 2015 14:00:00 +0200

cassandra-reaper (0.1.4-1) stable; urgency=low

  * Fixed bug that sometimes prevented scheduler from starting new runs
  * Made it possible to manually abort a repair run
  * Changed CLI to default to start a repair run when creating it
  * Added scheduled status(es) to cluster run
  * Improved logging

 -- Jimmy Mårdell <yarin@spotify.com>  Tue, 8 Apr 2015 18:00:00 +0100

cassandra-reaper (0.1.3-1) stable; urgency=low

  * Fixed bug where cluster resource never returned 404
  * Small tweaks to response from cluster resource

 -- Björn Hegerfors <bj0rn@spotify.com>  Tue, 24 Mar 2015 18:00:00 +0100

cassandra-reaper (0.1.2-1) stable; urgency=low

  * New response for cluster endpoint
  * Fixed bug in spreaper's --start-repair flag
  * Fixed bug where paused schedules would get resumed when starting up

 -- Björn Hegerfors <bj0rn@spotify.com>  Tue, 17 Mar 2015 18:17:44 +0100

cassandra-reaper (0.1.1-1) stable; urgency=low

  * Added deletion endpoints
  * Fixed repair runner bugs

 -- Björn Hegerfors <bj0rn@spotify.com>  Fri, 27 Feb 2015 11:35:26 +0100

cassandra-reaper (0.1.0-1) stable; urgency=low

  * First working release
  * Added scheduling funtionality

 -- Hannu Varjoranta <varjo@spotify.com>  Fri, 13 Feb 2015 12:34:03 +0100

cassandra-reaper (0.0.2-1) unstable; urgency=low

  * Initial working version
  * Changed to use Upstart instead of Supervision

 -- Hannu Varjoranta <varjo@spotify.com>  Thu, 8 Jan 2015 15:24:13 +0100

cassandra-reaper (0.0.1-1) unstable; urgency=low

  * Initial build

 -- Björn Hegerfors <bj0rn@spotify.com>  Mon, 24 Nov 2014 13:56:51 +0100
