=== rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# the default LDFLAGS="-Wl,-Bsymbolic-functions" caused rsyslog to
# segfault on receipt of first message (see LP: #794230)
unexport LDFLAGS

%:
	dh $@ --with autoreconf
#org	dh $@ --with autotools_dev

override_dh_auto_configure:
	dh_auto_configure -- \
		--disable-libgcrypt \
		--disable-liblogging-stdlog \
		--enable-elasticsearch \
		--enable-imkafka=optional \
		--enable-omkafka=optional \
		--enable-mysql \
		--enable-pgsql \
		--enable-mmrm1stspace \
		--enable-mmfields \
		--enable-fmhash \
		--enable-fmhttp \
		--enable-gnutls \
		--enable-openssl \
		--enable-imfile \
		--enable-impstats \
		--enable-imjournal=optional \
		--enable-imptcp \
		--enable-mail \
		--enable-clickhouse \
		--enable-mmanon \
		--enable-mmdblookup=optional \
		--enable-mmjsonparse \
		--enable-mmkubernetes \
		--enable-mmnormalize \
		--enable-mmpstrucdata \
		--enable-mmsequence \
		--enable-mmutf8fix \
		--enable-omhiredis=no \
		--enable-omhiredis=no \
		--enable-omhttp \
		--enable-omprog \
		--enable-omstdout \
		--enable-omuxsock \
		--enable-openssl \
		--enable-libdbi=optional \
		--enable-relp \
		--with-systemdsystemunitdir=/lib/systemd/system

#
#		 --enable-gt-ksi \
#                --enable-gssapi-krb5 \
#                --enable-ommongodb \
#                --enable-imzmq3 \
#                --enable-omzmq3 \

override_dh_auto_install:
	dh_auto_install
#	install --mode=644 -D plugins/ommysql/createDB.sql debian/rsyslog-mysql/usr/share/dbconfig-common/data/rsyslog-mysql/install/mysql
#	install --mode=644 -D plugins/ompgsql/createDB.sql debian/rsyslog-pgsql/usr/share/dbconfig-common/data/rsyslog-pgsql/install/pgsql

override_dh_compress:
	dh_compress -X rsyslog-example.conf

override_dh_installinit:
	--profile-name=usr.sbin.rsyslogd -prsyslog
	dh_installinit -R

override_dh_auto_test:
ifeq (, $(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	make check || ( cat tests/test-suite.log; exit 1; )
endif
