=== src/packaging/debian/rules ===
#!/usr/bin/make -f
# Copyright 2014-2017 Spotify AB
# Copyright 2016-2018 The Last Pickle Ltd
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

DEB_DH_INSTALL_SOURCEDIR=debian/tmp
DEB_DH_INSTALLINIT_ARGS=-n

MVN = mvn -B -U -e -Dmaven.repo.local=$$PWD/.m2-repository
SUREFIRE = -Dsurefire.useFile=false

%:
	dh $@ --with=systemd

build:
	dh build --until dh_auto_build
	$(MVN) $(SUREFIRE) package
	dh build --remaining

binary:
	dh binary --until dh_fixperms
	dh binary --remaining

clean:
	dh clean
	$(MVN) clean
