=== debian/tests/control ===
Tests: python
Depends: python3, pycodestyle, pyflakes3

Tests: selftests
Restrictions: breaks-testbed, needs-root, isolation-machine
Depends: kexec-tools, python3, gcc, make, libpopt-dev, gcc-multilib [amd64], bc, fuse, libfuse-dev, pkg-config, linux-image-4.19.0-18-alpha-generic [alpha], linux-image-4.19.0-18-alpha-smp [alpha], linux-image-4.19.0-18-amd64-unsigned [amd64], linux-image-4.19.0-18-cloud-amd64-unsigned [amd64], linux-image-4.19.0-18-rt-amd64-unsigned [amd64], linux-image-4.19.0-18-arm64-unsigned [arm64], linux-image-4.19.0-18-rt-arm64-unsigned [arm64], linux-image-4.19.0-18-marvell [armel], linux-image-4.19.0-18-rpi [armel], linux-image-4.19.0-18-armmp [armhf], linux-image-4.19.0-18-armmp-lpae [armhf], linux-image-4.19.0-18-rt-armmp [armhf], linux-image-4.19.0-18-parisc [hppa], linux-image-4.19.0-18-parisc-smp [hppa], linux-image-4.19.0-18-parisc64-smp [hppa], linux-image-4.19.0-18-686-unsigned [i386], linux-image-4.19.0-18-686-pae-unsigned [i386], linux-image-4.19.0-18-rt-686-pae-unsigned [i386], linux-image-4.19.0-18-itanium [ia64], linux-image-4.19.0-18-mckinley [ia64], linux-image-4.19.0-18-m68k [m68k], linux-image-4.19.0-18-4kc-malta [mips mipsel], linux-image-4.19.0-18-5kc-malta [mips mips64 mips64el mipsel], linux-image-4.19.0-18-octeon [mips mips64 mips64el mipsel], linux-image-4.19.0-18-loongson-3 [mips64el mipsel], linux-image-4.19.0-18-mips64r6 [mips64r6 mipsr6], linux-image-4.19.0-18-mips64r6el [mips64r6el mipsr6el], linux-image-4.19.0-18-mips32r6 [mipsr6], linux-image-4.19.0-18-mips32r6el [mipsr6el], linux-image-4.19.0-18-powerpc [powerpc], linux-image-4.19.0-18-powerpc-smp [powerpc], linux-image-4.19.0-18-powerpc64 [powerpc ppc64], linux-image-4.19.0-18-powerpcspe [powerpcspe], linux-image-4.19.0-18-powerpc64le [ppc64el], linux-image-4.19.0-18-riscv64 [riscv64], linux-image-4.19.0-18-s390x [s390x], linux-image-4.19.0-18-sh7751r [sh4], linux-image-4.19.0-18-sh7785lcr [sh4], linux-image-4.19.0-18-sparc64 [sparc64], linux-image-4.19.0-18-sparc64-smp [sparc64]
Classes: smp
